package com.eco.plugin.xx.bssso2.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "单点登录配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xx.idmsso.config", text = "单点登录配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "clientId", name = "应用id", description = "应用id", status = Status.SHOW)
    private Conf<String> clientId = Holders.simple("");

    @Identifier(value = "secret", name = "密钥", description = "密钥", status = Status.SHOW)
    private Conf<String> secret = Holders.simple("");

    @Identifier(value = "callback", name = "应用回调地址", description = "应用回调地址", status = Status.SHOW)
    private Conf<String> callback = Holders.simple("");

    @Identifier(value = "authUrl", name = "获取授权码接口", description = "获取授权码接口", status = Status.SHOW)
    private Conf<String> authUrl = Holders.simple("");

    @Identifier(value = "tokenUrl", name = "获取token接口", description = "获取token接口", status = Status.SHOW)
    private Conf<String> tokenUrl = Holders.simple("");

    @Identifier(value = "userUrl", name = "获取用户信息接口", description = "获取用户信息接口", status = Status.SHOW)
    private Conf<String> userUrl = Holders.simple("");

    public String getClientId() {
        return clientId.get();
    }

    public void setClientId(String url) {
        this.clientId.set(url);
    }

    public String getSecret() {
        return secret.get();
    }

    public void setSecret(String url) {
        this.secret.set(url);
    }

    public String getAuthUrl() {
        return authUrl.get();
    }

    public void setAuthUrl(String url) {
        this.authUrl.set(url);
    }

    public String getTokenUrl() {
        return tokenUrl.get();
    }

    public void setTokenUrl(String url) {
        this.tokenUrl.set(url);
    }

    public String getUserUrl() {
        return userUrl.get();
    }

    public void setUserUrl(String url) {
        this.userUrl.set(url);
    }

    public String getCallback() {
        return callback.get();
    }

    public void setCallback(String url) {
        this.callback.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
